---
title: WindowOrWorkerGlobalScope.atob()
slug: Web/API/WindowOrWorkerGlobalScope/atob
tags:
  - API
  - HTML DOM
  - Method
  - Reference
  - WindowOrWorkerGlobalScope
  - atob
---
<p>{{APIRef("HTML DOM")}}</p>

<p>The <strong><code>WindowOrWorkerGlobalScope.atob()</code></strong> function decodes a string of data which has been encoded using {{glossary("Base64")}} encoding. You can use the {{domxref("WindowOrWorkerGlobalScope.btoa","btoa()")}} method to encode and transmit data which may otherwise cause communication problems, then transmit it and use the <code>atob()</code> method to decode the data again. For example, you can encode, transmit, and decode control characters such as ASCII values 0 through 31.</p>

<p>For use with Unicode or UTF-8 strings, see the note on "Unicode strings" in the page for {{domxref("WindowOrWorkerGlobalScope.btoa", "btoa()")}}.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var <var>decodedData</var> = scope.atob(<var>encodedData</var>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>encodedData</var></code></dt>
 <dd>A <a href="/en-US/docs/Web/API/DOMString/Binary">binary string</a> contains an base64 encoded data.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>An ASCII string containing decoded data from <code><var>encodedData</var></code>.</p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt>{{domxref("DOMException")}} (name: <code>InvalidCharacterError</code>)</dt>
 <dd>Throws if <code><var>encodedData</var></code> is not valid base64.</dd>
</dl>

<h2 id="Example">Example</h2>

<pre class="brush:js notranslate">const encodedData = window.btoa('Hello, world'); // encode a string
const decodedData = window.atob(encodedData); // decode the string</pre>

<h2 id="Polyfill">Polyfill</h2>

<p>You can use a polifill from <a href="https://github.com/MaxArt2501/base64-js/blob/master/base64.js">https://github.com/MaxArt2501/base64-js/blob/master/base64.js</a> for browsers that don't support it.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', '#dom-atob', 'WindowOrWorkerGlobalScope.atob()')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td>Method moved to the <code>WindowOrWorkerGlobalScope</code> mixin in the latest spec.</td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5.1', '#dom-windowbase64-atob', 'WindowBase64.atob()')}}</td>
   <td>{{Spec2('HTML5.1')}}</td>
   <td>Snapshot of {{SpecName("HTML WHATWG")}}. No change.</td>
  </tr>
  <tr>
   <td>{{SpecName("HTML5 W3C", "#dom-windowbase64-atob", "WindowBase64.atob()")}}</td>
   <td>{{Spec2('HTML5 W3C')}}</td>
   <td>Snapshot of {{SpecName("HTML WHATWG")}}. Creation of <code>WindowBase64</code> (properties where on the target before it).</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.WindowOrWorkerGlobalScope.atob")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/HTTP/Basics_of_HTTP/Data_URIs"><code>data</code> URIs</a></li>
 <li>{{domxref("WindowOrWorkerGlobalScope.btoa","btoa()")}}</li>
 <li><a href="/en-US/docs/Mozilla/Tech/XPCOM/Language_Bindings/Components.utils.importGlobalProperties">Components.utils.importGlobalProperties</a></li>
</ul>
